package org.apache.maven.javacc;

/* ====================================================================
 *   Copyright 2001-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 * ====================================================================
 */

import org.javacc.parser.Main;

import java.io.File;
import java.util.ArrayList;

/**
 * 
 * @author <a href="michal.maczka@dimatics.com">Michal Maczka</a> 
 * @version $Id$
 */
public class JavaccBean extends BaseBean
{
    

    public int generate() throws Exception
    {
        final ArrayList params = new ArrayList();
        
        final File outputDir = getJavaccOutputDir();
        
        if ( !outputDir.exists() )
        {                
            
            outputDir.mkdirs();
        }
        
        params.add( "-OUTPUT_DIRECTORY=" + outputDir.getCanonicalPath() );        
        
        params.add( getGrammar() );
        
        String[] args = ( String[] ) params.toArray( new String[ params.size() ] );
        
        final int retValue = Main.mainProgram( args );
        
        //addHeader( outputDir );
        
        return retValue;
    }
    

}
